#!/usr/bin/python3
#  -*- coding: utf-8 -*-

import sys
import math

import heatflux

def read_data( filename ) :
    Points = []
    
    with open( filename, "r" ) as handle :
        for line in handle : # .readlines() :
            raw = heatflux.RawPoint( line )

            if raw.good :
                pt = heatflux.DataPoint( raw )

                if pt.good() :
                    Points.append( pt )
            
    return Points

def main( filename ) :
    Points = read_data( filename )

    if len(Points) > 0 :
        print( "Read <{}> points...".format(len(Points)), file=sys.stderr )
        print( heatflux.DataPoint.header() )

        for pt in Points :
            print( pt.line() )

main( sys.argv[1] )
