#!/usr/bin/python3
#  -*- coding: utf-8 -*-

import sys

this = sys.modules[__name__]
this.filename = this.handles = None
this.stdout = False
this.current = 0
this.newline = True

def openfile( filename, stdout=False ) :
    try :
        handle = open( filename, 'w' )

        if this.handles is None :
            this.handles = [ handle ]
        else :
            this.handles.append( handle )

    except :
        handle = None
        this.handles = None

    this.stdout = stdout

    return handle

def _newline() :
    if this.handles is None :
        print( "" )

    else :
        for h in this.handles :
            print( "", file=h )

        if this.stdout :
            print( "" )

    return

def clearpass() :
    this.current = 0

    return

def startpass() :
    this.current = 1

    return

def nextpass() :
    this.current += 1

    if this.newline :
        _newline()
    else :
        _newline()
        _newline()

        this.newline = True

    return

def log( line, end='\n', flush=True ) :
    if (this.current > 0) and this.newline :
        output = "(Pass {:02d}) {}".format( this.current, line )
    else :
        output = line
        
    if this.handles is None :
        print( output, end=end, flush=flush )
    else :
        for h in this.handles :
            print( output, file=h, end=end, flush=flush )

        if this.stdout :
            print( output, end=end, flush=flush )

    this.newline = (end == "\n")

    return

def close( h = None ) :
    if this.handles is not None :
        if h is None :
            for h in this.handles :
                h.close()

            this.handles = None
        elif h in this.handles :
            h.close()
            this.handles.remove( h )
            
            if len(this.handles) == 0 :
                this.handles = None

    return
