#!/usr/bin/python3
#  -*- coding: utf-8 -*-

import sys
import re

import numpy as np

import asciigrid

def write_punched( image, oldname ) :
    expr = re.compile( "^(.+)_(.+(?:(?<!\.txt)))(?:\.[a-z]+)+$" )
    result = expr.match( oldname )

    if result :
        filename = "{}_{}.punched.txt".format( result.group(1), result.group(2) )
        writer = asciigrid.GridWriter( image )

        data = np.array( image.data )
        data[image.ndmask] = image.nodata

        writer.write_image( data, filename )
        print( "Punched image written to file <{}>".format(filename) )
    else :
        print( "Filename <{}> does not seem in good format!" )
    exit( 0 )

    return

number = len( sys.argv )
print( number )
image = None

if number >= 2 :
    asciigrid.AsciiGrid.set_verbose( True )
    image = asciigrid.AsciiGrid( sys.argv[1], True )

    if image.is_good() :
        if number == 2 :
            image.plot()
        elif number == 5 :
            point = ( int(sys.argv[2]), int(sys.argv[3]) )

            image.punch( point, float(sys.argv[4]) )
            write_punched( image, sys.argv[1] )
            image.plot()
        else :
            print( "Wrong number of parameters." )
            print( "Usage: {} gridfile [px py r]".format(sys.argv[0]) )
    else :
        print( "Error reading image file <{}>: \"{}\"".format(sys.argv[1], image.last_error()) )
else :
    print( "Missing parameters" )
    print( "Usage: {} gridfile [px py r]".format(sys.argv[0]) )
