#!/usr/bin/python3
#  -*- coding: utf-8 -*-

import sys

import asciigrid

def superimpose( first, second, alpha ) :
    grid1 = asciigrid.AsciiGrid( first, True )
    grid2 = asciigrid.AsciiGrid( second, True )

    if not grid1.good or not grid2.good :
        print( "Error reading input file(s)" )
        return

    grid1.draw_both( grid2, alpha )

    return

if __name__ == "__main__" :
    number = len( sys.argv )
    if number == 3 :
        superimpose( sys.argv[1], sys.argv[2], 0.5 )
    elif number == 4 :
        superimpose( sys.argv[1], sys.argv[2], float(sys.argv[3]) )
    else :
        print( "Usage: {} <first> <second> [alpha]".format(sys.argv[0]) )
    
